// Code generated by goctl. DO NOT EDIT.
package handler

import (
	"net/http"

	auth "qnc-server/app/user/cmd/api/internal/handler/auth"
	pay "qnc-server/app/user/cmd/api/internal/handler/pay"
	product "qnc-server/app/user/cmd/api/internal/handler/product"
	query "qnc-server/app/user/cmd/api/internal/handler/query"
	user "qnc-server/app/user/cmd/api/internal/handler/user"
	"qnc-server/app/user/cmd/api/internal/svc"

	"github.com/zeromicro/go-zero/rest"
)

func RegisterHandlers(server *rest.Server, serverCtx *svc.ServiceContext) {
	server.AddRoutes(
		[]rest.Route{
			{
				// get mobile verify code
				Method:  http.MethodPost,
				Path:    "/auth/sendSms",
				Handler: auth.SendSmsHandler(serverCtx),
			},
		},
		rest.WithPrefix("/api/v1"),
	)

	server.AddRoutes(
		[]rest.Route{
			{
				Method:  http.MethodPost,
				Path:    "/pay/alipay/callback",
				Handler: pay.AlipayCallbackHandler(serverCtx),
			},
			{
				Method:  http.MethodPost,
				Path:    "/pay/wechat/callback",
				Handler: pay.WechatPayCallbackHandler(serverCtx),
			},
			{
				Method:  http.MethodPost,
				Path:    "/pay/wechat/refund_callback",
				Handler: pay.WechatPayRefundCallbackHandler(serverCtx),
			},
		},
		rest.WithPrefix("/api/v1"),
	)

	server.AddRoutes(
		rest.WithMiddlewares(
			[]rest.Middleware{serverCtx.SourceInterceptor},
			[]rest.Route{
				{
					Method:  http.MethodPost,
					Path:    "/pay/iap_callback",
					Handler: pay.IapCallbackHandler(serverCtx),
				},
				{
					Method:  http.MethodPost,
					Path:    "/pay/payment",
					Handler: pay.PaymentHandler(serverCtx),
				},
			}...,
		),
		rest.WithJwt(serverCtx.Config.JwtAuth.AccessSecret),
		rest.WithPrefix("/api/v1"),
	)

	server.AddRoutes(
		[]rest.Route{
			{
				Method:  http.MethodGet,
				Path:    "/:id",
				Handler: product.GetProductByIDHandler(serverCtx),
			},
			{
				Method:  http.MethodGet,
				Path:    "/en/:product_en",
				Handler: product.GetProductByEnHandler(serverCtx),
			},
		},
		rest.WithJwt(serverCtx.Config.JwtAuth.AccessSecret),
		rest.WithPrefix("/api/v1/product"),
	)

	server.AddRoutes(
		[]rest.Route{
			{
				// query general background check
				Method:  http.MethodPost,
				Path:    "/query/backgroundCheck",
				Handler: query.BackgroundCheckHandler(serverCtx),
			},
			{
				// query company info
				Method:  http.MethodPost,
				Path:    "/query/companyInfo",
				Handler: query.CompanyInfoHandler(serverCtx),
			},
			{
				// query home service
				Method:  http.MethodPost,
				Path:    "/query/homeService",
				Handler: query.HomeServiceHandler(serverCtx),
			},
			{
				// query marriage
				Method:  http.MethodPost,
				Path:    "/query/marriage",
				Handler: query.MarriageHandler(serverCtx),
			},
			{
				// query pre-loan background check
				Method:  http.MethodPost,
				Path:    "/query/preLoanBackgroundCheck",
				Handler: query.PreLoanBackgroundCheckHandler(serverCtx),
			},
			{
				// query rental info
				Method:  http.MethodPost,
				Path:    "/query/rentalInfo",
				Handler: query.RentalInfoHandler(serverCtx),
			},
			{
				// query risk assessment
				Method:  http.MethodPost,
				Path:    "/query/riskAssessment",
				Handler: query.RiskAssessmentHandler(serverCtx),
			},
			{
				// query service
				Method:  http.MethodPost,
				Path:    "/query/service/:product",
				Handler: query.QueryServiceHandler(serverCtx),
			},
		},
		rest.WithJwt(serverCtx.Config.JwtAuth.AccessSecret),
		rest.WithPrefix("/api/v1"),
	)

	server.AddRoutes(
		[]rest.Route{
			{
				// 查询详情
				Method:  http.MethodGet,
				Path:    "/query/:id",
				Handler: query.QueryDetailHandler(serverCtx),
			},
			{
				// 查询示例
				Method:  http.MethodGet,
				Path:    "/query/example",
				Handler: query.QueryExampleHandler(serverCtx),
			},
			{
				// 查询列表
				Method:  http.MethodGet,
				Path:    "/query/list",
				Handler: query.QueryListHandler(serverCtx),
			},
			{
				// 查询详情 按订单号 付款查询时
				Method:  http.MethodGet,
				Path:    "/query/orderId/:order_id",
				Handler: query.QueryDetailByOrderIdHandler(serverCtx),
			},
			{
				// 查询详情 按订单号
				Method:  http.MethodGet,
				Path:    "/query/orderNo/:order_no",
				Handler: query.QueryDetailByOrderNoHandler(serverCtx),
			},
			{
				// 获取查询临时订单
				Method:  http.MethodGet,
				Path:    "/query/provisional_order/:id",
				Handler: query.QueryProvisionalOrderHandler(serverCtx),
			},
			{
				// 重试查询
				Method:  http.MethodPost,
				Path:    "/query/retry/:id",
				Handler: query.QueryRetryHandler(serverCtx),
			},
		},
		rest.WithJwt(serverCtx.Config.JwtAuth.AccessSecret),
		rest.WithPrefix("/api/v1"),
	)

	server.AddRoutes(
		[]rest.Route{
			{
				// mobile code login
				Method:  http.MethodPost,
				Path:    "/user/mobileCodeLogin",
				Handler: user.MobileCodeLoginHandler(serverCtx),
			},
			{
				// mobile login
				Method:  http.MethodPost,
				Path:    "/user/mobileLogin",
				Handler: user.MobileLoginHandler(serverCtx),
			},
			{
				// register
				Method:  http.MethodPost,
				Path:    "/user/register",
				Handler: user.RegisterHandler(serverCtx),
			},
			{
				// wechat mini auth
				Method:  http.MethodPost,
				Path:    "/user/wxMiniAuth",
				Handler: user.WxMiniAuthHandler(serverCtx),
			},
			{
				// wechat h5 auth
				Method:  http.MethodPost,
				Path:    "/user/wxh5Auth",
				Handler: user.WxH5AuthHandler(serverCtx),
			},
		},
		rest.WithPrefix("/api/v1"),
	)

	server.AddRoutes(
		[]rest.Route{
			{
				// get user info
				Method:  http.MethodGet,
				Path:    "/user/detail",
				Handler: user.DetailHandler(serverCtx),
			},
		},
		rest.WithJwt(serverCtx.Config.JwtAuth.AccessSecret),
		rest.WithPrefix("/api/v1"),
	)
}
